<p align="center">

<img src="https://gblobscdn.gitbook.com/assets%2F-M1ejn7fVvN8DITsnKKs%2F-M24-WfIBJzIO_iGCiJ2%2F-M24-xNAI9CDmWJWk3YR%2Fpng-512-black.png?alt=media&token=387de1d2-2586-42d0-aa10-a8134f0eabf9" width="200" />
</p>

<h1 align="center">nanoexpress</h1>

<h3 align="center">Professional backend framework for Node.js</h3>

![Node.js CI](https://github.com/nanoexpress/nanoexpress/workflows/Node.js%20CI/badge.svg)
[![Code Climate](https://codeclimate.com/github/nanoexpress/nanoexpress/badges/gpa.svg)](https://codeclimate.com/github/nanoexpress/nanoexpress)
[![GitHub issues](https://img.shields.io/github/issues/nanoexpress/nanoexpress.svg)](http://github.com/nanoexpress/nanoexpress/issues)

<!-- [![Coverage Status](https://coveralls.io/repos/github/nanoexpress/nanoexpress/badge.svg?branch=master)](https://coveralls.io/github/nanoexpress/nanoexpress?branch=master) -->

## Special thanks / Sponsors

| Sponsor                                       | Since |
| --------------------------------------------- | ----- |
| [BrowserStack](https://www.browserstack.com/) | 2016  |
| [JetBrains](https://www.jetbrains.com/)       | 2019  |
| [Paw](https://paw.cloud/)                     | 2020  |
| [MacStadium](https://www.macstadium.com/)     | 2020  |
| [GitPod](https://www.gitpod.io/)              | 2022  |

as well as [Sergey NN](https://github.com/mrauhu) and
[Yaroslav Dobzhanskij](https://github.com/yarsky-tgz) for
being Gold+ sponsors for short period of time

## TO-DO / Roadmap

- [ ] `/get_schema` — Ajv Request Validator
- [ ] ESLint plugin for nanoexpress (for better performance)
- [ ] TypeScript integration
- [ ] JSDoc comments
- [ ] Better documentations
- [x] nanoexpress EcoSystem (middlewares, defines, plugins)
- [ ] Live reload page
- [ ] staticServe watchMode
- [x] Get query (400x faster)
- [ ] GraphQL subscription
- [ ] Hooks support
- [ ] AWS-S3 Middleware
- [ ] Dropbox Integration
- [ ] WebRTC integration
- [ ] Torrent-server implementation
- [ ] socketi Integration (Pusher API)
- [ ] MQTT Syntax (test with clients)
- [ ] Server-side events (test)
- [ ] EventSource
- [ ] Built-in fast logger (with ELK integration)
- [ ] nanoORM written in AssemblyScript (for PostgreSQL, MySQL and SQLite)
- [ ] Live backend builder

## Table of Contents

- [Documentations](https://nanoexpress.js.org)
- [Configurations](https://nanoexpress.js.org/server#simple-version)
- [Middlewares](https://nanoexpress.js.org/middlewares)
- [Routes and route expose](https://nanoexpress.js.org/routes)
- [WebSocket](https://nanoexpress.js.org/websocket)
- [Docker](https://nanoexpress.js.org/docker-linux)
- [Benchmarks](https://nanoexpress.js.org/benchmark) and [Live benchmarks](https://github.com/the-benchmarker/web-frameworks#results)
- [FAQ](https://nanoexpress.js.org/faq)

## How to Contribute

Whether you're helping us fix bugs, improve the docs, or spread the word, we'd love to have you as part of the nanoexpress community!

Check out our [Contributing Guide](https://github.com/nanoexpress/nanoexpress/blob/master/CONTRIBUTING.md) for ideas on contributing and setup steps for getting our repositories up and running on your local machine.

## Support

Thank you, all previous sponsors, backers and supporters

### Sponsors

See [here](https://nanoexpress.js.org/sponsors)

## License

[Apache-2.0](https://nanoexpress.js.org/license)
